package xyz.etztech.deluxegroups.listeners;

import github.scarsz.discordsrv.api.Subscribe;
import github.scarsz.discordsrv.api.events.DiscordGuildMessagePreProcessEvent;
import github.scarsz.discordsrv.api.events.GameChatMessagePreProcessEvent;
import org.bukkit.ChatColor;
import xyz.etztech.deluxegroups.DeluxeGroup;
import xyz.etztech.deluxegroups.DeluxeGroups;
import xyz.etztech.deluxegroups.DeluxeUtil;

import java.util.ArrayList;
import java.util.List;

public class DiscordSRVListener {

    private DeluxeGroups plugin;
    private List<String> groupPrefixes;

    public DiscordSRVListener(DeluxeGroups deluxeGroups) {
        this.plugin = deluxeGroups;
        reload();
    }

    public void reload() {
        this.groupPrefixes = new ArrayList<>();
        this.groupPrefixes.addAll(DeluxeUtil.trimmed(this.plugin.getConfig().getStringList("prefix")));
    }

    @Subscribe
    public void onDiscordMessage(DiscordGuildMessagePreProcessEvent event) {
        event.setCancelled(true);
        if (DeluxeGroups.getDatabase().groupExists(event.getChannel().getName())) {
            DeluxeGroup group = DeluxeGroups.getDatabase().getGroup(event.getChannel().getName());
            String format = plugin.getConfig().getString("dtm", "[DISCORD | <group>] <player> > <message>");
            String chat = format.
                    replace("<group>", group.getName()).
                    replace("<message>", event.getMessage().getContentStripped()).
                    replace("<author>", event.getAuthor().getName());
            chat = ChatColor.translateAlternateColorCodes('&', chat);
            group.sendMessage(chat);
        }
    }

    @Subscribe
    public void onMinecraftMessage(GameChatMessagePreProcessEvent event) {
        String chat = event.getMessage();
        boolean groupChat = false;
        for (String prefix : this.groupPrefixes) {
            // If chat starts with 1 prefix, it is group chat.
            if (chat.startsWith(prefix)) {
                groupChat = true;
                chat = chat.substring(1);
                // If chat still starts with the prefix, it means there were two and we are delegating to normal chat
                if (chat.startsWith(prefix)) {
                    event.setMessage(chat);
                    return;
                }
                break;
            }
        }
        if (groupChat) {
            event.setCancelled(true);
        }
    }
}
